
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class FeedbacksDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const feedbacks = await db.feedbacks.create(
            {
                id: data.id || undefined,
        
        rating: data.rating
        ||
        null
            ,
            
        comments: data.comments
        ||
        null
            ,
            
        submitted_at: data.submitted_at
        ||
        null
            ,
            
        visibility: data.visibility
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await feedbacks.setPatient( data.patient || null, {
            transaction,
        });
        
        await feedbacks.setDoctor( data.doctor || null, {
            transaction,
        });
        
        await feedbacks.setConsultation( data.consultation || null, {
            transaction,
        });
        
        await feedbacks.setCamp( data.camp || null, {
            transaction,
        });
        
        await feedbacks.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return feedbacks;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const feedbacksData = data.map((item, index) => ({
                id: item.id || undefined,
                
                rating: item.rating
            ||
            null
            ,
            
                comments: item.comments
            ||
            null
            ,
            
                submitted_at: item.submitted_at
            ||
            null
            ,
            
                visibility: item.visibility
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const feedbacks = await db.feedbacks.bulkCreate(feedbacksData, { transaction });

        // For each item created, replace relation files
        

        return feedbacks;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const feedbacks = await db.feedbacks.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.rating !== undefined) updatePayload.rating = data.rating;
        
        
        if (data.comments !== undefined) updatePayload.comments = data.comments;
        
        
        if (data.submitted_at !== undefined) updatePayload.submitted_at = data.submitted_at;
        
        
        if (data.visibility !== undefined) updatePayload.visibility = data.visibility;
        
        
        updatePayload.updatedById = currentUser.id;

        await feedbacks.update(updatePayload, {transaction});

        
        
        if (data.patient !== undefined) {
            await feedbacks.setPatient(
              
              data.patient,
              
              { transaction }
            );
        }
        
        if (data.doctor !== undefined) {
            await feedbacks.setDoctor(
              
              data.doctor,
              
              { transaction }
            );
        }
        
        if (data.consultation !== undefined) {
            await feedbacks.setConsultation(
              
              data.consultation,
              
              { transaction }
            );
        }
        
        if (data.camp !== undefined) {
            await feedbacks.setCamp(
              
              data.camp,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await feedbacks.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return feedbacks;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const feedbacks = await db.feedbacks.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of feedbacks) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of feedbacks) {
                await record.destroy({transaction});
            }
        });


        return feedbacks;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const feedbacks = await db.feedbacks.findByPk(id, options);

        await feedbacks.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await feedbacks.destroy({
            transaction
        });

        return feedbacks;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const feedbacks = await db.feedbacks.findOne(
            { where },
            { transaction },
        );

        if (!feedbacks) {
            return feedbacks;
        }

        const output = feedbacks.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.patient = await feedbacks.getPatient({
            transaction
        });
        
        
        output.doctor = await feedbacks.getDoctor({
            transaction
        });
        
        
        output.consultation = await feedbacks.getConsultation({
            transaction
        });
        
        
        output.camp = await feedbacks.getCamp({
            transaction
        });
        
        
        output.organizations = await feedbacks.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.patient_profiles,
        as: 'patient',
        
        where: filter.patient ? {
          [Op.or]: [
            { id: { [Op.in]: filter.patient.split('|').map(term => Utils.uuid(term)) } },
            {
              patient_identifier: {
                [Op.or]: filter.patient.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.doctor_profiles,
        as: 'doctor',
        
        where: filter.doctor ? {
          [Op.or]: [
            { id: { [Op.in]: filter.doctor.split('|').map(term => Utils.uuid(term)) } },
            {
              specialization: {
                [Op.or]: filter.doctor.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.consultations,
        as: 'consultation',
        
        where: filter.consultation ? {
          [Op.or]: [
            { id: { [Op.in]: filter.consultation.split('|').map(term => Utils.uuid(term)) } },
            {
              chief_complaint: {
                [Op.or]: filter.consultation.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.medical_camps,
        as: 'camp',
        
        where: filter.camp ? {
          [Op.or]: [
            { id: { [Op.in]: filter.camp.split('|').map(term => Utils.uuid(term)) } },
            {
              camp_name: {
                [Op.or]: filter.camp.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.comments) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'feedbacks',
                        'comments',
                        filter.comments,
                    ),
                };
            }
            

            
            

            
            if (filter.ratingRange) {
                const [start, end] = filter.ratingRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    rating: {
                    ...where.rating,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    rating: {
                    ...where.rating,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.submitted_atRange) {
                const [start, end] = filter.submitted_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    submitted_at: {
                    ...where.submitted_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    submitted_at: {
                    ...where.submitted_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.visibility) {
                where = {
                    ...where,
                visibility: filter.visibility,
            };
            }
            


      

      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.feedbacks.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'feedbacks',
                        'comments',
                        query,
                    ),
                ],
            };
        }

        const records = await db.feedbacks.findAll({
            attributes: [ 'id', 'comments' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['comments', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.comments,
        }));
    }

    
};

